#include "parse_number.h"

long long signed int
parse_number(char * string)
{
  char * str_tail;
  long long signed int x, e, base;
  x = strtoll(string, &str_tail, 10);
  if (string != str_tail)
  {
    switch (str_tail[0])
    {
      case 'k':
        e = 1;
        str_tail += 1;
        break;

      case 'M':
        e = 2;
        str_tail += 1;
        break;

      case 'G':
        e = 3;
        str_tail += 1;
        break;

      case 'T':
        e = 4;
        str_tail += 1;
        break;

      case 'P':
        e = 5;
        str_tail += 1;
        break;

      case 'E':
        e = 6;
        str_tail += 1;
        break;

      case 'Z':
        e = 7;
        str_tail += 1;
        break;

      case 'Y':
        e = 8;
        str_tail += 1;
        break;

      default:
        e = 0;
    }
    if (str_tail[0] == 'B')
    {
      base = 1000;
    }
    // iB or nothing
    else
    {
      base = 1024;
    }
    for (; e; e--)
    {
      x *= base;
    }
    return x;
  }
  fprintf(stderr, "error: failed to parse number (%s)\n", string);
  exit(EXIT_FAILURE);
}
